<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/language.oop5.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'fr',
  ),
  'this' => 
  array (
    0 => 'language.oop5.autoload.php',
    1 => 'Auto-chargement de classes',
  ),
  'up' => 
  array (
    0 => 'language.oop5.php',
    1 => 'Les classes et les objets',
  ),
  'prev' => 
  array (
    0 => 'language.oop5.constants.php',
    1 => 'Constantes de classe',
  ),
  'next' => 
  array (
    0 => 'language.oop5.decon.php',
    1 => 'Constructeurs et destructeurs',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'fr',
    'path' => 'language/oop5/autoload.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="language.oop5.autoload" class="sect1">
 <h2 class="title">Auto-chargement de classes</h2>
 <p class="para">
  De nombreux développeurs qui écrivent des applications orientées objet
  créent un fichier source par définition de classe. Un des plus gros inconvénients
  de cette méthode est d&#039;avoir à écrire une longue liste d&#039;inclusions de
  fichier de classes au début de chaque script : une inclusion par classe.
 </p>
 <p class="para">
  La fonction <span class="function"><a href="function.spl-autoload-register.php" class="function">spl_autoload_register()</a></span> enregistre un nombre quelconque de
  chargeurs automatiques, ce qui permet aux classes et aux interfaces d&#039;être
  automatiquement chargées si elles ne sont pas définies actuellement.
  En enregistrant des autochargeurs, PHP donne une dernière chance d&#039;inclure une
  définition de classe ou interface, avant que PHP n&#039;échoue avec une erreur.
 </p>
 <p class="para">
  Toute construction similaire à des classes peuvent être autochargées de la
  même manière. Ceci inclut les classes, interfaces, trait, et énumérations.
 </p>
 <div class="caution"><strong class="caution">Attention</strong>
  <p class="para">
   Antérieur à PHP 8.0.0, il était possible d&#039;utiliser <span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span>
   pour autocharger les classes et interfaces. Cependant c&#039;est une alternative
   moins flexible à <span class="function"><a href="function.spl-autoload-register.php" class="function">spl_autoload_register()</a></span> et
   <span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span> est obsolète à partir de PHP 7.2.0,
   et supprimée à partir de PHP 8.0.0.
  </p>
 </div>
 <blockquote class="note"><p><strong class="note">Note</strong>: 
  <p class="para">
   <span class="function"><a href="function.spl-autoload-register.php" class="function">spl_autoload_register()</a></span> peut être appelée plusieurs fois
   pour enregistrer plusieurs autochargeur. Lancer une exception depuis une
   fonction d&#039;autochargement, interrompra ce processus et ne permet pas aux
   fonctions d&#039;autochargement suivantes à être exécutées. Pour cette raison,
   lancer des exceptions depuis une fonction d&#039;autochargement est fortement
   découragée.
  </p>
 </p></blockquote>
 <p class="para">
  <div class="example" id="example-295">
   <p><strong>Exemple #1 Exemple d&#039;autochargement</strong></p>
   <div class="example-contents"><p>
    Cet exemple tente de charger les classes <code class="literal">MaClasse1</code>
    et <code class="literal">MaClasse2</code>, respectivement depuis les fichiers
    <var class="filename">MaClasse1.php</var> et
    <var class="filename">MaClasse2.php</var>.
   </p></div>
   <div class="example-contents">
<div class="annotation-interactive phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />spl_autoload_register</span><span style="color: #007700">(function (</span><span style="color: #0000BB">$class_name</span><span style="color: #007700">) {<br />    include </span><span style="color: #0000BB">$class_name </span><span style="color: #007700">. </span><span style="color: #DD0000">'.php'</span><span style="color: #007700">;<br />});<br /><br /></span><span style="color: #0000BB">$obj  </span><span style="color: #007700">= new </span><span style="color: #0000BB">MaClasse1</span><span style="color: #007700">();<br /></span><span style="color: #0000BB">$obj2 </span><span style="color: #007700">= new </span><span style="color: #0000BB">MaClasse2</span><span style="color: #007700">();<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

  </div>
  <div class="example" id="example-296">
   <p><strong>Exemple #2 Autre exemple d&#039;autochargement</strong></p>
   <div class="example-contents"><p>
    Cet exemple tente de charger l&#039;interface <code class="literal">ITest</code>.
   </p></div>
   <div class="example-contents">
<div class="annotation-interactive phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br /><br />spl_autoload_register</span><span style="color: #007700">(function (</span><span style="color: #0000BB">$name</span><span style="color: #007700">) {<br />    </span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$name</span><span style="color: #007700">);<br />});<br /><br />class </span><span style="color: #0000BB">Foo </span><span style="color: #007700">implements </span><span style="color: #0000BB">ITest </span><span style="color: #007700">{<br />}<br /><br /></span><span style="color: #FF8000">/*<br />string(5) "ITest"<br /><br />Fatal error: Interface 'ITest' not found in ...<br />*/<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
    </div>

   </div>
   <div class="example" id="example-297">
    <p><strong>Exemple #3 Utilisation de l&#039;autoloader de Composer</strong></p>
    <div class="example-contents"><p>
     <a href="https://getcomposer.org/" class="link external">&raquo;&nbsp;Composer</a> génère un fichier <code class="literal">vendor/autoload.php</code>
     configuré pour charger automatiquement les packages gérés par Composer.
     En incluant ce fichier, ces packages peuvent être utilisés sans travail
     supplémentaire.
    </p></div>
    <div class="example-contents">
<div class="annotation-interactive phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br /></span><span style="color: #007700">require </span><span style="color: #0000BB">__DIR__ </span><span style="color: #007700">. </span><span style="color: #DD0000">'/vendor/autoload.php'</span><span style="color: #007700">;<br /><br /></span><span style="color: #0000BB">$uuid </span><span style="color: #007700">= </span><span style="color: #0000BB">Ramsey\Uuid\Uuid</span><span style="color: #007700">::</span><span style="color: #0000BB">uuid7</span><span style="color: #007700">();<br /><br />echo </span><span style="color: #DD0000">"Nouvel UUID généré -&gt; "</span><span style="color: #007700">, </span><span style="color: #0000BB">$uuid</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">toString</span><span style="color: #007700">(), </span><span style="color: #DD0000">"\n"</span><span style="color: #007700">;<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

  </div>
 </p>
 
 <div class="simplesect">
  <h3 class="title">Voir aussi</h3>
  <p class="para">
   <ul class="simplelist">
     <li><span class="function"><a href="function.unserialize.php" class="function">unserialize()</a></span></li>
     <li><a href="var.configuration.php#ini.unserialize-callback-func" class="link">unserialize_callback_func</a></li>
     <li><a href="var.configuration.php#ini.unserialize-max-depth" class="link">unserialize_max_depth</a></li>
     <li><span class="function"><a href="function.spl-autoload-register.php" class="function">spl_autoload_register()</a></span></li>
     <li><span class="function"><a href="function.spl-autoload.php" class="function">spl_autoload()</a></span></li>
     <li><span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span></li>
    </ul>
  </p>
 </div>
</div><?php manual_footer($setup); ?>